'use strict';

var qe = require('crypto');
var we = require('fs');
var path = require('path');
var promises = require('fs/promises');
var Yr = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var qe__default = /*#__PURE__*/_interopDefault(qe);
var we__default = /*#__PURE__*/_interopDefault(we);
var Yr__default = /*#__PURE__*/_interopDefault(Yr);

var et=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function no(e,t=void 0){return JSON.stringify(e,et,t)}function xn(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let u=n.indexOf(this);~u?n.splice(u+1):n.push(this),~u?r.splice(u,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);i=et(o,i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function M(e,t,n,r){return JSON.stringify(e,xn(t,r),n)}var ro=M;function bn(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Tn(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var ue;function tt(e){if(ue==null&&(ue=bn,typeof TextEncoder<"u")){let t=new TextEncoder;ue=n=>t.encode(n);}return ue(e.normalize("NFC"))}var ce;function nt(e){if(ce==null&&(ce=Tn,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});ce=n=>t.decode(n);}return ce(e).normalize("NFC")}function F(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?tt(e):e.length?new Uint8Array(e):e}function so(...e){let t=0,n=e.flat(1).map(i=>{let u=F(i);return t+=u.length,u}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function rt(e){if(typeof Buffer<"u")return Buffer.from(F(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...F(e)])n+=t[r>>4]+t[r&15];return n}function ot(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function it(e,t=!1){let n=F(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function ao(e){let t=F(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function wn(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function uo(e){return nt(wn(e))}function st(e,t){if(e.byteLength!==t.byteLength)return !1;let n=F(e),r=F(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function ve(e){return tt(M(e))}function Ae(e){return JSON.parse(nt(e))}function at(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),u=`0000${o.toString(16)}`.slice(-4),a=i.split("").map(c=>{let p=c.charCodeAt(0);return ` ${r[(240&p)>>4]}${r[15&p]}`}).join("");a+="   ".repeat(t-i.length);let s=i.replace(/[\x00-\x1F\x20]/g,".");s+=" ".repeat(t-i.length),n.push(`${u} ${a}  ${s}`);}return n.join(`
`)}function K(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var ct="SHA-256",Ee="AES-GCM",ut="PBKDF2",Ln=1e5;async function fo(e,t=ct){return F(await crypto.subtle.digest(t,F(e)))}async function po(e,t={}){let n=F(e),r=await crypto.subtle.importKey("raw",n,ut,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:ut,salt:t.salt?F(t.salt):new Uint8Array(0),iterations:t.iterations??Ln,hash:ct},r,{name:Ee,length:256},!0,["encrypt","decrypt"])}function lt(){return new Uint8Array([1,1])}async function ft(e,t){let n=lt(),r=K(12),o=await crypto.subtle.encrypt({name:Ee,iv:r},t,e),i=new Uint8Array(o),u=n.length+r.length+i.length,a=new Uint8Array(u),s=0;return a.set(n,s),s+=n.length,a.set(r,s),s+=r.length,a.set(i,s),a}async function dt(e,t){let n=e.subarray(0,2);if(!st(n,lt()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:Ee,iv:r},t,o);return new Uint8Array(i)}function vn(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function S(){return typeof crypto<"u"?vn():Math.random()}function mo(e=.25){return S()<e}function yo(e=100,t=0){return t+Math.floor(S()*(e-t))}function ho(e=100,t=0){return t+S()*(e-t)}function xo(e,t,n){return Math.max(e,Math.min(n,t))}function An(e){return e.reduce((t,n)=>t+n,0)}function bo(e){return An(e)/e.length}function To(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function wo(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var Pe=6;function Lo(e=0,t=1,n){Pe=((n??Pe)*9301+49297)%233280;let r=Pe/233280;return t+r*(e-t)}function En(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function Ao(e,t=!0){return `${e} ${t?"asc":"desc"}`}function De(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Eo(e,...t){if(t.length>0){let n=t.map(En),r=Array.from(e);return r.sort((o,i)=>{for(let{field:u,asc:a}of n){let s=De(o[u],i[u],a);if(s!==0)return s}return 0}),r}return e}function Se(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Pn(e,t){return Se(e.filter(n=>!t.includes(n)))}function Dn(...e){return Se(e.reduce((t=[],n)=>t.concat(n),[]))}function Y(...e){return e.flat(1/0)}function Sn(e,t){return Se(e).filter(n=>t.includes(n))}function Ro(e,t){return Pn(Dn(e,t),Sn(e,t))}function pt(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function Uo(e,t){return e.includes(t)||e.push(t),e}function Re(e,t){return e.splice(0,e.length,...e.filter(t)),e}function Mo(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function Fo(e){return e.splice(0,e.length),e}function Rn(e,t=De){return Array.from(e).sort(t)}function ko(e){return Rn(e,(t,n)=>t-n)}function Un(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function gt(e){return e.sort(()=>S()>.5?1:-1),e}function Co(e){return gt(Array.from(e))}function Io(e){for(;e.length>1;){let t=Array.from(e);if(gt(t),!Un(e,t))return t}return e}function $o(e){return e[Math.floor(S()*e.length)]}function Oo(...e){return Y(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Bo(...e){return Y(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function _o(...e){return Y(e).reduce((t,n)=>t+n,0)}function jo(...e){let t=Y(e);return t.reduce((n,r)=>n+r,0)/t.length}function Ho(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function No(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var Mn={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function Fn(e){let t=Mn[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let p=t.charAt(c),l=p.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${p} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),u=Math.log(256)/Math.log(r);function a(c,p=-1){let l=F(c);if(l.byteLength===0)return "";let f=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let y=(g-d)*u+1>>>0,b=new Uint8Array(y);for(;d!==g;){let A=l[d],P=0;for(let h=y-1;(A!==0||P<f)&&h!==-1;h--,P++)A+=256*b[h]>>>0,b[h]=A%r>>>0,A=A/r>>>0;if(A!==0)throw new Error("Non-zero carry");f=P,d++;}let m=y-f;for(;m!==y&&b[m]===0;)m++;let w="";for(;m<y;++m)w+=t.charAt(b[m]);return p>0?w.padStart(p,o):w}function s(c,p=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let m=0;for(let w=d-1;(b!==0||m<f)&&w!==-1;w--,m++)b+=r*g[w]>>>0,g[w]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=m,l++;}let y=d-f;for(;y!==d&&g[y]===0;)y++;return p>0?new Uint8Array([...new Uint8Array(p-g.length+y),...g.slice(y)]):g.slice(y)}return {encode:a,decode:s}}var le;function G(e){le==null&&(le=new Map);function t(){let o=le.get(e);return o==null&&(o=Fn(e),le.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function Ue(e,t=-1){return G(32).encode(e,t)}function mt(e,t=-1){return G(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function Vo(e,t=-1){return G(16).encode(e,t)}function qo(e,t=-1){return G(16).decode(e,t)}function Wo(e,t=-1){return G(58).encode(e,t)}function Jo(e,t=-1){return G(58).decode(e,t)}function Me(e,t=-1){return G(62).encode(e,t)}function yt(e,t=-1){return G(62).decode(e,t)}function Zo(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var ht=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function kn(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function Yo(e){return e.replace(/\w\S*/g,kn)}function Qo(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var xt=["1","true","yes","y","on"];function ti(e,t=!1){return e==null||typeof e!="string"?t:xt.includes(String(e).trim().toLowerCase())}function ni(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function ri(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function Q(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:xt.includes(String(e).trim().toLowerCase())}function Cn(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function In(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function Fe(e,t=""){return e==null?t:String(e)??t}var oi=In,ii=Cn,si=Fe,ai=Q;function $n(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${at(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function fe(e,t={}){return $n(e,t).join(" ")}function ui(e){try{return decodeURIComponent(escape(e))}catch{}return e}var bt=864e5;function Ce(e){return Math.floor(e/1e4)}function Tt(e){return Math.floor(e/100%100)}function On(e){return Math.floor(e%100)}function li(e){return [Ce(e),Tt(e),On(e)]}function wt(e,t=!1){return t?new Date(`${_n(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Lt(){return pe(new Date)}function fi(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return vt(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return Ie(n,r,o)}else if(e instanceof Date)return pe(e,t)}function di(e){return wt(e,!0)}function pe(e,t=!1){return t?vt(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function pi(e){return pe(e,!0)}function ke(e,t=!0){return wt(e,t).getTime()}function Bn(e,t=!0){return pe(new Date(e),t)}function _n(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function Ie(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function vt(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function gi(e,t=0){let n=Ce(e),r=Tt(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),Ie(n,r,1)}function mi(e,t=0){let n=Ce(e);return Ie(n+t,1,1)}function de(e,t){return Bn(ke(e)+t*864e5)}function yi(e,t){return Math.round((ke(t)-ke(e))/864e5)}function hi(e,t){let n=[];for(t==null&&(t=Lt()),e<0&&(e=de(t,e+1));e<=t;)n.push(e),e=de(e,1);return n}function*xi(e,t){let n=[];for(t==null&&(t=Lt()),e<0&&(e=de(t,e+1));e<=t;)yield e,e=de(e,1);return n}function At(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Ti(e){return new Promise(t=>setTimeout(t,e))}async function wi(){return new Promise(e=>setTimeout(e,0))}async function Li(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,u=setTimeout(()=>{i=!0,r(n);},t);try{let a=await e;clearTimeout(u),i||r(a);}catch(a){clearTimeout(u),i||o(a);}})}function vi(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function Et(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let u=await e;clearTimeout(i),o||n(u);}catch(u){clearTimeout(i),o||r(u);}})}function Ai(e,t,n=1e3){return new Promise((r,o)=>{let i=s=>{a&&(clearTimeout(a),u(),r(s));},u=()=>{a=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},a=setTimeout(()=>{u(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function k(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function j(e){return Promise.resolve(e)}var v=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=v.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new v(t)}static fromString(t){return v.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?v.fromString(t.toISOString().substr(0,10)):v.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return v.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new v(t);if(typeof t=="string")return v.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new v(r*1e4+o*100+i)}else {if(t instanceof Date)return v.fromDate(t,n);if(t instanceof v)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return v.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return v.from([this.year,this.month,1])}yearStart(){return v.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return v.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new v(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function Di(e,t,n){let r=v.from(e),o=v.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);k(i)&&await i,r=r.dayOffset(1);}}function Si(){return new v}function Ri(e){return new v(e)}function Ui(e){return v.fromDate(new Date(e)).days}function jn(e,t=2){return +(+e).toFixed(t)}function Fi(e,t=2){return +(+e/10**t).toFixed(t)}function ki(e,t=2){return Math.round(+e*10**t)}function Ci(e,t=2){return t*(jn(e,t)%1)}function H(e){return e!=null&&typeof e=="object"}function $e(e){return Object(e)!==e}function N(e){return Array.isArray(e)}function ge(e){return H(e)&&!N(e)}function $i(e){return e?.constructor===Object}function Pt(e){return typeof e=="string"}function Dt(e){return typeof e=="number"&&!isNaN(e)}function Oi(e){return Dt(e)&&Number.isInteger(e)}function Bi(e){return Dt(e)&&Number.isSafeInteger(e)}function St(e){return typeof e=="boolean"}function _i(e){return e==null}function ji(e){return e==null}function Hi(e){return H(e)&&e.constructor.name==="Uint8Array"}function Rt(e){return e!=null}function Ni(e){return e!=null&&e!==!1&&e!==!0}function Hn(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||($e(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!Hn(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function Nn(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if($e(e)||t.add(e),ge(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}Nn(e[n],t);}}else if(N(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function me(e,...t){for(let n of t)H(e)||(e={}),!(n==null||!H(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):H(o)&&H(i)?e[r]=me(Object.assign({},o),i):e[r]=i;});return e}var Ut=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),qi=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function Ji(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function Zi(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function Ki(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function Yi(e,t){return e.map(n=>n[t])}function es(e,t){return H(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return N(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function ts(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function ns(e){return Object.keys(e).length<=0}var Mt=/[\u0000-\u001F\u0080-\u009F]/g,Gn=/^\.+/,zn=/\.+$/;function Ft(){return /[<>:"/\\|?*\u0000-\u001F]/g}function Vn(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function kt(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(Ft().test(t)&&Mt.test(t))throw new Error("Replacement string cannot contain reserved filename characters");return e=e.replace(Ft(),t).replace(Mt,t).replace(Gn,t).replace(zn,""),e=Vn().test(e)?e+t:e,e.slice(0,100)}var qn=/[\\\-\[\]\/{}()*+?.^$|]/g;function Ct(e){return e?e instanceof RegExp?e.source:e.replace(qn,"\\$&"):""}var ne=e=>Math.abs(e)%1===.5,It=e=>e%2===0,ss=e=>Math.ceil(e),as=e=>Math.floor(e),us=e=>Math.round(e),cs=e=>{let t=Math.round(e);return ne(e)&&It(t)?t-1:t},ls=e=>ne(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),fs=e=>ne(e)?Math.floor(e):Math.round(e),ds=e=>{let t=Math.round(e);return ne(e)?It(t)?t:t-1:t},ps=e=>ne(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function $t(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-S()}function Ot(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+S()}function ys(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return Ot(n);if(e<=0)return $t(n);n=Wn([...n]);let i=o?-1:0,u=n[e+i].sort_weight||0,s=(n[e+i+1].sort_weight||0)-u;if(s===0)return o?$t(n):Ot(n);let c=u+s/2,p=s*.01*(S()-.5);return c+p}function Wn(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function bs(e={}){let{getter:t=a=>a.sort}=e;function n(a){return a.sort((s,c)=>(t(s)||0)-(t(c)||0)),a}function r(a){return a.reduce((s,c)=>Math.min(s,t(c)||0),0)-1-S()}function o(a){return a.reduce((s,c)=>Math.max(s,t(c)||0),0)+1+S()}function i(a,s){a==null&&(a=(s??0)-1),s==null&&(s=(a??0)+1);let c=s-a,p=a+c/2,l=c*.01*(S()-.5);return p+l}function u(a,s,c){let p=c.length,l=a<s;if(p<=0||a>=p-1)return o(c);if(a<=0)return r(c);c=n([...c]);let f=l?-1:0,d=t(c[a+f])||0,y=(t(c[a+f+1])||0)-d;if(y===0)return l?r(c):o(c);let b=d+y/2,m=y*.01*(S()-.5);return b+m}return {start:r,end:o,between:i,move:u,items:n}}var Jn=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function Ls(e){return e.split(Jn).map((t,n)=>{let r=Ut(t);return n%2?`<a target="_blank" href="${r}">${Zn(r)}</a>`:r}).join("")}function Zn(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function Bt(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function vs(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),u=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(u)):t[i]=u;}return t}function Ps(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function Ds(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Ss(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function Rs(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function Us(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function X(e){return Object(e)!==e?e:JSON.parse(M(e))}function Ms(e){return Object(e)!==e?e:JSON.parse(M(e))}function Fs(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function ks(e){let t=new Map;return async(...n)=>{let r=M(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function Cs(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}var Kn=/\\\s|\s+|#[^\n]*\n?/gm,Yn=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,_t=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Qn(e){return typeof e=="string"?e:e.source||""}function $s(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var jt=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(Kn,a=>a[0]==="\\"?a:"")),!(t instanceof RegExp)){let a=0;o=o.replace(Yn,(s,c)=>(a+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=a),"("):s)),this.names=Object.keys(this.namedGroups);}o=Qn(o),_t.lastIndex=0;let u=_t.exec(o);u&&(this.lookBehind={rx:new RegExp(`${u[3]}$(?!\\s)`),expect:u?u[2]==="=":!u},o=o.substr(u[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Xn=",";function _s(e,t={}){let{separator:n=Xn}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(St(i))return i?1:0;let u=String(i);return (ge(i)||N(i))&&(u=M(i)),u.includes('"')||u.includes(`
`)||u.includes(n)?`"${u.replace(/"/g,'""')}"`:u}).join(n)}
`;return r}function er(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Ct(t.separator)),n.flags));let r=[],o=[],i,u=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(u);){let a=i[2]??i[3]??"";a=a.replaceAll('""','"'),o.push(a),i[4]===`
`&&(r.push(o),o=[]);}return r}function js(e,t={}){let n=er(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,u)=>[r[u],i])))}function tr(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function re(){let e=tr();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function nr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function rr(){return nr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function _(e=rr()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),u=i.length;for(o=0;o<u;o++){if(!i[o])continue;let a=i[o].replace(/\*/g,".*?");a[0]==="-"?n.push(new RegExp(`^${a.substr(1)}$`)):r.push(new RegExp(`^${a}$`));}t=function(a){if(n.length===0&&r.length===0)return !0;let s,c;for(s=0,c=n.length;s<c;s++)if(n[s].test(a))return !1;for(s=0,c=r.length;s<c;s++)if(r[s].test(a))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function or(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Oe(e){if(e===!1)return ee;if(typeof e=="number")return e;if(typeof e=="string"){let t=Ht[e.toLocaleLowerCase().trim()];if(t!=null)return t}return V}function z(e=or()){let t=Oe(e);return n=>n>=t}function ye(e={}){let{level:t=void 0,filter:n=void 0}=e,r=_(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let u=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${u}`,...i.messages);break;case I:console.warn(`W|**  ${u}`,...i.messages);break;case $:console.error(`E|*** ${u}`,...i.messages);break;default:console.debug(`D|    ${u}`,...i.messages);break}}}var V=-1,q=0,O=1,I=2,$=3,he=4,ee=9007199254740991,Ht={"*":V,a:V,all:V,d:q,dbg:q,debug:q,i:O,inf:O,info:O,w:I,warn:I,warning:I,e:$,err:$,error:$,fatal:he,off:ee,"-":ee};function Nt(e=""){let t=[ye()],n=s=>!0,r=!1,o=u,i=!1;function u(s="",c){let p=Oe(c??V);function l(g,y){return p<=g?y:()=>{}}let f=l(q,(...g)=>{d({name:s,messages:g,level:q});});f.label=s,f.extend=function(g){return o(s?`${s}:${g}`:g)};let d=g=>{if(n(s))for(let y of t)y&&y(g);};return f.debug=l(q,(...g)=>{d({name:s,messages:g,level:q});}),f.info=l(O,(...g)=>{d({name:s,messages:g,level:O});}),f.warn=l(I,(...g)=>{d({name:s,messages:g,level:I});}),f.error=l($,(...g)=>{d({name:s,messages:g,level:$});}),f.fatal=l(he,(...g)=>{throw d({name:s,messages:g,level:he}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(he,(g,...y)=>{g||f.fatal(...y);}),f}function a(s="",c){let p=o(s,c);return i&&p.debug(`+++ init of logger "${s}" on level "${p.level}".`),p}return a.registerHandler=function(s){t.push(s);},a.setFilter=function(s){n=_(s);},a.setLock=(s=!0)=>r=s,a.setDebug=(s=!0)=>i=s,a.setHandlers=function(s=[]){o!==u&&(o=u),!r&&(t=[...s].filter(c=>typeof c=="function"));},a.level=V,a.setLogLevel=function(s=V){r||(a.level=s);},a.setFactory=function(s){r||(o=s);},a}var W;function Be(e){let t=Nt();return e?e(t):t.setHandlers([ye()]),t}function _e(e){if(W==null)try{let t=re();t!=null?t?.logger==null?(W=Be(e),t.logger=W):W=t.logger:W=Be(e);}catch{W=Be(e);}return W}function U(e,t){return _e()(e,t)}async function ir(e){typeof e=="function"?await j(e()):k(e)?await e:typeof e.dispose=="function"?await j(e.dispose()):k(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await j(e.cleanup()):k(e.cleanup)&&await e.cleanup;}function oe(e){let t=e;t!=null&&(Pt(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??U("zeed:dispose"),o=[],i=async s=>{s!=null&&o.includes(s)&&(Re(o,c=>c!==s),await ir(s));},u=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},a=s=>{if(s!=null)return o.unshift(s),()=>i(s)};return Object.assign(u,{track:a,add:a,untrack:i,dispose:u,exec:u,getSize(){return o.length},isDisposed(){return o.length<=0}})}var ia=oe;function sa(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let u=n[0];if(Re(n,a=>a!==u),typeof u=="function"){let a=u();if(k(a)){if(i)throw new Error(`Expected sync only function, but found async: ${u}`);await a;}}else if(k(u)){if(i)throw new Error(`Expected sync only function, but found async: ${u}`);await u;}else throw new Error(`Unhandled disposable: ${u}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function aa(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function ua(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function ca(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function da(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function pa(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();k(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();k(o)&&await o;}return r}}var C=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=U("zeed:emitter","error");this.dispose=oe();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(u=>{try{return j(u(...n))}catch(a){this._logEmitter.warn("emit warning:",a);}return null}).filter(u=>u!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await j(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Ta(){let e=re().emitter;return e||(e=new C,re().emitter=e),e}function wa(e,t){let n=Math.round(S()*100),r=[],o,i=(a,s)=>{let c={key:a,obj:s};r.push(c),o&&o();};return t?e.on?e.on(t,a=>{i(t,a);}):e.addEventListener?e.addEventListener(t,a=>{i(t,a);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((a,s)=>{i(a,s);}):e.log.error(n,"cannot listen to all for",e),(a,s=!0)=>new Promise((c,p)=>{a||(a=t,a||r.length&&(a=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===a)o=void 0,c(l.obj);else {if(s)continue;p(new Error(`Expected ${a}, but found ${l.key} with value=${l.obj}`));}break}},o();})}var ie=()=>Date.now();function Gt(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function va(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var xe=16;function He(){return K(xe)}function sr(e=He()){return Me(e,22)}function ar(e){return Me(e,22)}function ur(e){return yt(e,xe)}function cr(e=He()){return Ue(e,26)}function lr(e){return Ue(e,26)}function fr(e){return mt(e,xe)}var dr="10000000-1000-4000-8000-100000000000",pr=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():dr.replace(/[018]/g,e=>(e^K(1)[0]&15>>e/4).toString(16))};function gr(e){let t=rt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function mr(e){return ot(e.replaceAll("-",""))}var zt=16e11;function yr(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Vt(){let e=ie()-zt;return new Uint8Array([...yr(e),...K(10)])}function Ra(){return xr(Vt())}function Ua(e){return hr(Wt(e))}function hr(e){return new Date(zt+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function Ma(){return new Uint32Array(K(4))[0]}var Ne={base62:{uuid:sr,uuidDecode:ur,uuidEncode:ar},base32:{uuid:cr,uuidDecode:fr,uuidEncode:lr},uuidv4:{uuid:pr,uuidDecode:mr,uuidEncode:gr}},be="base62",qt=!1;function Fa(e,t=!1){be=e,qt=t;}function J(){return Ne[be].uuid(qt?Vt():He())}function Wt(e){return Ne[be].uuidDecode(e)}function xr(e){return Ne[be].uuidEncode(e)}function ka(e){try{return Wt(e).length===xe}catch{}return !1}var je={};function B(e="id"){return je[e]==null&&(je[e]=0),`${e}-${je[e]++}`}var br=0;function Ca(){return `id-${br++}`}var Ge=class extends C{constructor(){super(...arguments);this.id=J();}close(){this.dispose();}},Te=class extends Ge{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:J()});}};function Ba(){let e=new Te,t=new Te;return e.other=t,t.other=e,[e,t]}var Jt=class{async encode(t){return t}async decode(t){return t}},te=class{async encode(t){return ve(t)}async decode(t){return Ae(t)}},Zt=class{constructor(t){this.key=t;}async encode(t){let n=ve(t);return await ft(n,this.key)}async decode(t){let n=await dt(t,this.key);return Ae(n)}};var Kt=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function Ja(e={}){let{name:t=B("hub"),encoder:n=new te,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,u=U(t,i),a={},s,c=[],p,l={},f=()=>{clearTimeout(p);},d=async()=>{if(clearTimeout(p),s){if(s.isConnected)for(;c.length;){let m=c[0];try{s.postMessage(await n.encode(m)),c.shift();}catch(w){u.warn("postMessage",w);break}}c.length>0&&r>0&&(p=setTimeout(d,r));}},g=async m=>{u("enqueue postMessage",m),c.push(m),await d();},y=async m=>{s=m,s.on("connect",d),s.on("message",async w=>{u("onmessage",typeof w);let{name:A,args:P,id:h,result:x,error:L}=await n.decode(w.data);if(A){u(`name ${A} id ${h}`);try{if(a[A]==null)throw new Error(`handler for ${A} was not found`);let E=a[A](...P);k(E)&&(E=await E),u(`result ${E}`),h&&await g({id:h,result:E});}catch(E){let T=E instanceof Error?E:new Error(Fe(E));u.warn("execution error",T.name),await g({id:h,error:{message:T.message,stack:T.stack,name:T.name}});}}else if(h)if(u(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?u(`skip response for ${h}`):u.warn(`no response hook for ${h}`);else {let[E,T]=l[h];if(E&&T)if(delete l[h],L){let D=new Error(L.message);D.stack=L.stack,D.name=L.name,u.warn("reject",D.name),T(D);}else u("resolve",x),E(x);}else o||u.warn("Unhandled message",w);}),await d();},b=async(m,w,A={})=>{let{timeout:P=5e3}=A,h=J();return await g({name:m,args:w,id:h}),Et(new Promise((x,L)=>l[h]=[x,L]),P)};return e.channel&&y(e.channel),{dispose:f,connect:y,listen(m){Object.assign(a,m);},send(){return Kt(b,{},{options(m){return Kt(b,{...m})}})}}}var ze=class extends C{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new te,channel:i,debug:u=!1}=n;this.channel=i,this.encoder=o,this.debug=u,this.name=r??this.channel.id??B("pubsub"),this.log=U(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:a})=>{let s=await this.encoder.decode(a);if(this.debug?this.log(`channel message, event=${s?.event}, info=`,s):this.log(`channel message, event=${s?.event}`),s){let{event:c,args:p}=s;await this.emitSuper(c,...p);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function eu(e){return new ze(e)}var Tr=1;var Yt=e=>e,wr=Yt;function nu(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Yt,deserialize:u=wr}=t,a=new Map;return r(async s=>{let c=u(s),[p,l,f,d]=c;if(p===1||p===2){let g,y;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){y=String(b);}else y="Method implementation missing";p===1&&f&&n(i(y?[4,y,f]:[3,g,f]));}else if(f){let g=a.get(f);g!=null&&(p===4?g.reject(l):g.resolve(l)),a.delete(f);}}),new Proxy({},{get(s,c){let p=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return p.asEvent=p,p;let l=(...f)=>new Promise((d,g)=>{let y=Tr++;a.set(y,{resolve:d,reject:g}),n(i([1,f,y,c]));});return l.asEvent=p,l}})}var Z=class extends C{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??B("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Z(n);return this.addChild(r),r}removeChild(n){pt(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function pu(e={}){let{maxParallel:t=3,name:n=B("pool"),idConflictResolution:r="memoize"}=e,o=new C,i=oe();i.add(w);let u=new Z({name:n});u.on("progressCancelled",w);let a=0,s=0,c=0,p=0,l={};async function f(){if(a>0){let[h,x]=At();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),a=0,s=0,d(),u.reset();}function y(){let h=0,x=0;for(let{max:L,resolved:E,state:T}of Object.values(l))h+=L,x+=T==="finished"?L:Math.min(L,E);o.emit("didUpdate",a,s,h,x);}function b(){if(y(),a>0&&a===s&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(E=>E.state==="running"&&E.id!==L.id&&E.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,E=x.done;x.state="running",++c,o.emit("didStart",L);let T=D=>{x&&(x.result=D,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++s,b();};x.task(x).then(D=>{E(D),o.emit("didResolve",L,D),T(D);}).catch(D=>{E(),o.emit("didReject",L,D),T();});}}}function m(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++s,o.emit("didCancel",h),l[h].progress.dispose(),y());}function w(){Object.keys(l).forEach(m);}function A(h){return l[h]!=null}function P(h,x={}){let L,E=new Promise(R=>L=R),T=x.id??J();if(l[T]!=null){let R=x.idConflictResolution??r;if(R==="replace")m(T);else if(R==="memoize"||R==="prioritize"){let Xe=l[T];return R==="prioritize"&&(Xe.priority=++p),{id:T,promise:(async()=>{if(Xe.state==="finished")return l[T].result})(),dispose:()=>m(T),cancel:()=>m(T)}}else throw new Error(`Pool task with id=${T} already exists!`)}let D=new Z({name:T,totalUnits:x.max??1,completeUnits:x.resolved??0});return u.addChild(D),l[T]={id:T,task:h,priority:++p,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:D,setMax(R){D.setTotalUnits(R),l[T].max=R,y();},setResolved(R){D.setCompletetedUnits(R),l[T].resolved=R,y();},incResolved(R=1){D.incCompletedUnits(R),l[T].resolved+=R,y();}},++a,b(),{id:T,promise:E,dispose:()=>m(T),cancel:()=>m(T)}}return {events:o,cancel:m,cancelAll:w,hasById:A,progress:u,enqueue:P,dispose:i,waitFinishAll:f}}var Qt=class extends C{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=B("queue"),logLevel:o}=n;this.name=r,this.log=U(`zeed:queue:${r}`,o??ee);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let u;try{this.log.info(`start task ${r}`),u=await this.currentTask,this.log(`finished task ${r} with result =`,u);}catch(a){this.log.warn("Error performing task",a);}i(u),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=B(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(u=>{this.queue.push({name:i,task:n,resolve:u}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function wu(e,t={}){let {delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,u=0,a=0,s;function p(){return i?(clearTimeout(i),i=void 0,!0):!1}function l(...f){let d=Date.now(),g=d-u;let b=()=>{a=0,u=Date.now(),e.apply(this,f);};if(s=b,g>n||!i){o&&(g>n?b():++a);let m=g>n?n:n-g;p(),u=d,i=setTimeout(()=>{i=0,r&&(!o||a>0)&&s?.();},m);}else ++a;}return l.cancel=p,l.stop=()=>{p()&&s&&s();},l.immediate=async function(...d){p(),u=Date.now(),e.apply(this,d);},l.dispose=()=>l.stop(),l}function Lu(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function u(){r&&(clearTimeout(r),r=0);}async function a(){try{if(u(),i!=null){let p=[...i];i=void 0,o=!0,await j(e(...p)),o=!1,i!=null&&(u(),r=setTimeout(a,n));}}catch{}}function s(...p){i=[...p],u(),o===!1&&(r=setTimeout(a,n));}async function c(...p){u(),i=[...p],await a();}return s.cancel=u,s.dispose=u,s.immediate=c,s}function Au(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}function Du(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=_(n),i=z(t);return u=>{i(u.level)&&o(u.name)&&r.push(u);}}var Ve={cache:"no-cache",redirect:"follow",headers:{}};function Lr(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function Xt(e,t={},n=fetch){try{N(t)&&(t=me({},...Y(t)));let r=Lr(String(e));r&&(e=r.url,t=me({},t,vr(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=U("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(u){i.error("Exception:",u);}}catch(r){U("zeed:network").error("fetchBasic",r);}}async function Fu(e,t={},n=fetch){try{let r=await Xt(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){U("zeed:network").error("fetchJSON error:",r);}}async function ku(e,t={},n=fetch){try{let r=await Xt(e,[Ve,{method:"GET"},t],n);if(r)return await r.text()}catch(r){U("zeed:network").error("fetchHTML error:",r);}}function Cu(e,t="POST"){return {method:t,...Ve,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:Bt(e)}}function Iu(e,t="POST"){return {method:t,...Ve,headers:{"Content-Type":"application/json; charset=utf-8"},body:M(e)}}function vr(e,t){return {headers:{Authorization:`Basic ${it(`${e}:${t}`)}`}}}function en(){if(typeof window<"u")return window}function Ar(){if(typeof navigator<"u")return navigator}function Ou(){return en()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function Bu(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Ar(),n=en();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function Er(){return typeof window<"u"&&globalThis===window}function _u(e){Er()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var tn=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=X(n);}getItem(t){return X(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var Gu=()=>{};function qu(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=ht,booleanArgs:o=[],listArgs:i=[],numberArgs:u=[]}=e,a=Object.entries(n).reduce((f,d)=>{let[g,y]=d;typeof y=="string"&&(y=[y]);for(let b of y)f[r(b)]=r(g);return f},{}),s={_:[]};function c(f,d){s[f]==null||typeof s[f]=="boolean"?s[f]=d:Array.isArray(s[f])?s[f].push(d):s[f]=[s[f],d];}let p=[...t],l;for(;l=p.shift();){let f;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,y]=d.split("=",2);d=g.trim(),f=y.trim();}d=r(d),d=a[d]??d,o.includes(d)?c(d,!0):(f=f??p.shift()??"",u.includes(d)&&(f=Number(f??0)),i.includes(d)?Array.isArray(s[d])?s[d].push(f):s[d]=[f]:c(d,f));}else s._.push(l);}return s}function Ju(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function Yu(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&qe__default.default&&qe__default.default.webcrypto&&(globalThis.crypto=qe__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function Qu(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var Dr=`
`,Sr=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Rr=/\\n/g,Ur=/\n|\r|\r\n/;function nn(e,t={}){let n={};return String(e).split(Ur).forEach((r,o)=>{let i=r.match(Sr);if(i!=null){let u=i[1],a=i[2]||"",s=a.length-1,c=a[0]==='"'&&a[s]==='"';a[0]==="'"&&a[s]==="'"||c?(a=a.substring(1,s),c&&(a=a.replace(Rr,Dr))):a=a.trim(),n[u]=a;}}),n}function Mr(e,t="."){return path.resolve(process.cwd(),e??t)}function Fr(e,t=""){return e==null&&(e=t),Mr(String(e).trim(),t)}var We=Fr;function nc(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function rc(e={}){let t=e?.path??We(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=we__default.default.existsSync(t)?nn(we__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=we__default.default.existsSync(`${t}.local`)?nn(we__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},u=Object.assign({},o,i),a=e?.env??process.env;return Object.entries(u).forEach(([s,c])=>{typeof e?.prefix=="string"&&(s=e?.prefix+s),Object.prototype.hasOwnProperty.call(a,s)||c!=null&&(a[s]=c);}),{parsed:u}}catch(o){return {error:o}}}var sn=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?M(n,null,2):M(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??kt;}setItem(t,n){this.store[t]=X(n);try{let r=this.objectToString(n),o=this.getPath(t);we.mkdirSync(path.dirname(o),{recursive:!0}),we.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(we.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return X(n);try{let r=this.getPath(t),o=we.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);we.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},we.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=we.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};function pc(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function Ze(e){try{await promises.stat(e);}catch{return !1}return !0}async function gc(...e){let t=path.join(...e);return await Ze(t)||await promises.mkdir(t,{recursive:!0}),t}async function mc(...e){let t=path.join(...e);return await Ze(t)&&await promises.rm(t,{recursive:!0}),t}async function yc(...e){let t=path.join(...e);if(await Ze(t))return await promises.readFile(t,"utf-8")}async function hc(e,t){await promises.writeFile(e,t,"utf-8");}var an={};function un(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),we.mkdirSync(path.dirname(e),{recursive:!0});let u=we.createWriteStream(e,{flags:"a"}),a=_(r),s=z(n);return c=>{if(!s(c.level)||!a(c.name))return;let p=o?`${new Date().toISOString()} `:"",l=c.name||"",f=an[l||""];f==null&&(an[l]=f);let d=[`[${l||"*"}]`,fe(c.messages,{pretty:i})];function g(...y){u.write(`${y.join("	")}
`);}switch(c.level){case O:g(`${p}I|*  `,...d);break;case I:g(`${p}W|** `,...d);break;case $:g(`${p}E|***`,...d);break;default:g(`${p}D|   `,...d);break}}}function Zr(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Rt)??[]}function ln(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Kr(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function Ke(e=2,t=!0){let n=new Error("stack").stack||"",r=Zr(n)?.[e];return r&&t&&(r=ln(r)),r||""}function fn(){return new Error("stack").stack||""}function dn(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(u=>u.trim()),i=o.findIndex(u=>e.some(a=>u.startsWith(a)));n=o[i+1],n&&(n=Kr(n)),n&&t&&(n=ln(n));}return n}function Qr(){try{return Q(process.env.ZEED_COLOR,Yr__default.default.isatty(process.stdout.fd))}catch{}return !1}var Ye,pn=[6,2,3,4,5,1];function Xr(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return pn[Math.abs(t)%pn.length]}var gn={},Qe;function Le(...e){process.stdout.write(`${fe(e)}
`);}var ae={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var yn="\x1B[0m";function se(e,t){return `${t===8?ae.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${yn}`}function mn(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=yn;return n&&(o=`${ae.BOLD}${o}`,i=`${i}${ae.BOLD}`),`${o}${r}${i}`})}var eo="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function hn(e={}){Ye==null&&(Ye=Qr()),Qe==null&&(Qe=ie());let{level:t=void 0,filter:n=void 0,colors:r=Ye,levelHelper:o=!0,nameBrackets:i=!0,padding:u=0,fill:a=0,stack:s=!0,time:c=!0}=e,p=_(n),l=z(t);return f=>{if(!l(f.level)||!p(f.name))return;let d=ie(),g=f.name||"",y=gn[g||""];y==null&&(y={color:Xr(g)},gn[g]=y);let b=Gt(d-Qe),m,w=i?`[${g}]`:g;if(u>0&&(w=w.padStart(u," ")),a>0&&(w=w.padEnd(a," ")),r){let h=y.color;m=[`${se(w,h)} | `],f.level===I?m.push(...mn(f.messages,ae.ORANGE)):f.level===$?m.push(...mn(f.messages,ae.RED)):m.push(...f.messages),c&&m.push(se(`+${b}`,h));}else m=[w,...f.messages],c&&m.push(`+${b}`);if(f.messages?.[0]===eo&&console.log(fn()),s){let h="";typeof s=="boolean"?(h=dn(["at Function.","at null.log (","at log ("],!0),h||(h=Ke(0,!0))):h=Ke(typeof s=="number"?s:3,!0),h&&m.push(se(`(${h})`,7));}let A="|",P=".";switch(f.level){case O:o&&(m[0]=`I${A}${P}   ${m[0]}`),Le(...m);break;case I:o&&(m[0]=(r?se(`W${A}${P}${P}  `,8):`W${A}${P}${P}  `)+m[0]),Le(...m);break;case $:o&&(m[0]=(r?se(`E${A}${P}${P}${P} `,1):`E${A}${P}${P}${P} `)+m[0]),Le(...m);break;default:o&&(m[0]=`D${A}    ${m[0]}`),Le(...m);break}}}function to(e,t){return _e(n=>{let r=[hn({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=Q(process.env.ZEED_TIME,!0),u=Q(process.env.ZEED_PRETTY,!1);o&&r.unshift(un(We(o),{time:i,pretty:u})),n.setHandlers(r);})(e,t)}

exports.CRYPTO_DEFAULT_ALG = Ee;
exports.CRYPTO_DEFAULT_DERIVE_ALG = ut;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Ln;
exports.CRYPTO_DEFAULT_HASH_ALG = ct;
exports.Channel = Ge;
exports.CryptoEncoder = Zt;
exports.DAY_MS = bt;
exports.Day = v;
exports.DefaultLogger = U;
exports.Emitter = C;
exports.FileStorage = sn;
exports.JsonEncoder = te;
exports.LocalChannel = Te;
exports.LogLevelAlias = Ht;
exports.LogLevelAll = V;
exports.LogLevelDebug = q;
exports.LogLevelError = $;
exports.LogLevelFatal = he;
exports.LogLevelInfo = O;
exports.LogLevelOff = ee;
exports.LogLevelWarn = I;
exports.Logger = to;
exports.LoggerConsoleHandler = ye;
exports.LoggerContext = Nt;
exports.LoggerFileHandler = un;
exports.LoggerMemoryHandler = Du;
exports.LoggerNodeHandler = hn;
exports.MemStorage = tn;
exports.NoopEncoder = Jt;
exports.Progress = Z;
exports.PubSub = ze;
exports.SerialQueue = Qt;
exports.Uint8ArrayToHexDump = at;
exports.Uint8ArrayToJson = Ae;
exports.Uint8ArrayToString = nt;
exports.XRX = jt;
exports._decodeUtf8Polyfill = Tn;
exports._encodeUtf8Polyfill = bn;
exports._useBase = Fn;
exports.arrayAvg = jo;
exports.arrayBatches = Ho;
exports.arrayEmptyInPlace = Fo;
exports.arrayFilterInPlace = Re;
exports.arrayFlatten = Y;
exports.arrayIntersection = Sn;
exports.arrayIsEqual = Un;
exports.arrayMax = Oo;
exports.arrayMin = Bo;
exports.arrayMinus = Pn;
exports.arrayRandomElement = $o;
exports.arrayRemoveElement = pt;
exports.arraySetElement = Uo;
exports.arrayShuffle = Co;
exports.arrayShuffleForce = Io;
exports.arrayShuffleInPlace = gt;
exports.arraySorted = Rn;
exports.arraySortedNumbers = ko;
exports.arraySum = _o;
exports.arraySymmetricDifference = Ro;
exports.arrayToggleInPlace = Mo;
exports.arrayUnion = Dn;
exports.arrayUnique = Se;
exports.avg = bo;
exports.between = xo;
exports.cloneJsonObject = Ms;
exports.cloneObject = X;
exports.cmp = De;
exports.colorString = se;
exports.colorStringList = mn;
exports.composeOrderby = Ao;
exports.createArray = No;
exports.createLocalChannelPair = Ba;
exports.createPromise = At;
exports.createPromiseProxy = Kt;
exports.csvParse = er;
exports.csvParseToObjects = js;
exports.csvStringify = _s;
exports.dateStringToDays = Ui;
exports.day = Ri;
exports.dayDay = On;
exports.dayDiff = yi;
exports.dayFromAny = fi;
exports.dayFromDate = pe;
exports.dayFromDateGMT = pi;
exports.dayFromParts = Ie;
exports.dayFromString = vt;
exports.dayFromTimestamp = Bn;
exports.dayFromToday = Lt;
exports.dayIterator = xi;
exports.dayMonth = Tt;
exports.dayMonthStart = gi;
exports.dayOffset = de;
exports.dayRange = hi;
exports.dayToDate = wt;
exports.dayToDateGMT = di;
exports.dayToParts = li;
exports.dayToString = _n;
exports.dayToTimestamp = ke;
exports.dayYear = Ce;
exports.dayYearStart = mi;
exports.debounce = Lu;
exports.decimal = jn;
exports.decimalCentsPart = Ci;
exports.decimalFromCents = Fi;
exports.decimalToCents = ki;
exports.decodeBase16 = qo;
exports.decodeBase32 = mt;
exports.decodeBase58 = Jo;
exports.decodeBase62 = yt;
exports.decrypt = dt;
exports.deepEqual = Hn;
exports.deepMerge = me;
exports.deepStripUndefinedInPlace = Nn;
exports.deriveKeyPbkdf2 = po;
exports.detect = Bu;
exports.digest = fo;
exports.empty = Us;
exports.encodeBase16 = Vo;
exports.encodeBase32 = Ue;
exports.encodeBase58 = Wo;
exports.encodeBase62 = Me;
exports.encodeQuery = Bt;
exports.encrypt = ft;
exports.endSortWeight = Ot;
exports.ensureFolder = gc;
exports.ensureKey = Ps;
exports.ensureKeyAsync = Ds;
exports.equalBinary = st;
exports.escapeHTML = Ut;
exports.escapeRegExp = Ct;
exports.estimateSizeForBase = Zo;
exports.exists = Ze;
exports.fetchBasic = Xt;
exports.fetchJson = Fu;
exports.fetchOptionsBasicAuth = vr;
exports.fetchOptionsFormURLEncoded = Cu;
exports.fetchOptionsJson = Iu;
exports.fetchText = ku;
exports.fixBrokenUth8String = ui;
exports.forEachDay = Di;
exports.forTimes = Cs;
exports.formatMessages = $n;
exports.formatMilliseconds = Gt;
exports.fromBase64 = wn;
exports.fromBase64String = uo;
exports.fromCamelCase = Qo;
exports.fromHex = ot;
exports.getEnvVariableRelaxed = nc;
exports.getGlobal = Ou;
exports.getGlobalContext = re;
exports.getGlobalEmitter = Ta;
exports.getGlobalLogger = _e;
exports.getNamespaceFilterString = nr;
exports.getNavigator = Ar;
exports.getSecureRandom = vn;
exports.getSecureRandomIfPossible = S;
exports.getSourceLocation = Ke;
exports.getSourceLocationByPrecedingPattern = dn;
exports.getStack = fn;
exports.getStackLlocationList = Zr;
exports.getTimestamp = ie;
exports.getWebCrypto = Qu;
exports.getWindow = en;
exports.immediate = wi;
exports.isArray = N;
exports.isBoolean = St;
exports.isBrowser = Er;
exports.isEven = It;
exports.isHalf = ne;
exports.isInteger = Oi;
exports.isLocalHost = Au;
exports.isNotNull = Rt;
exports.isNull = ji;
exports.isNullOrUndefined = _i;
exports.isNumber = Dt;
exports.isObject = H;
exports.isPrime = wo;
exports.isPrimeRX = To;
exports.isPrimitive = $e;
exports.isPromise = k;
exports.isRecord = ge;
exports.isRecordPlain = $i;
exports.isSafeInteger = Bi;
exports.isString = Pt;
exports.isTimeout = vi;
exports.isUint8Array = Hi;
exports.isValue = Ni;
exports.joinToUint8Array = so;
exports.jsonStringify = ro;
exports.jsonStringifySafe = M;
exports.jsonStringifySorted = no;
exports.jsonToUint8Array = ve;
exports.last = Rs;
exports.lazyListener = wa;
exports.linkifyPlainText = Ls;
exports.listDistinctUnion = Ki;
exports.listGroupBy = Zi;
exports.listOfKey = Yi;
exports.listQuery = Ji;
exports.loggerStackTraceDebug = eo;
exports.memoize = Fs;
exports.memoizeAsync = ks;
exports.moveSortWeight = ys;
exports.noop = Gu;
exports.objectIsEmpty = ns;
exports.objectMap = es;
exports.objectMergeDisposable = ts;
exports.parseArgs = qu;
exports.parseBasicAuth = Lr;
exports.parseDate = va;
exports.parseLogLevel = Oe;
exports.parseOrderby = En;
exports.parseQuery = vs;
exports.pbcopy = Ju;
exports.promisify = j;
exports.qid = Ca;
exports.randomBoolean = mo;
exports.randomFloat = ho;
exports.randomInt = yo;
exports.randomUint8Array = K;
exports.readText = yc;
exports.regExpEscape = $s;
exports.regExpString = Qn;
exports.removeFolder = mc;
exports.renderMessages = fe;
exports.roundDown = as;
exports.roundHalfAwayFromZero = ls;
exports.roundHalfDown = fs;
exports.roundHalfEven = ds;
exports.roundHalfOdd = cs;
exports.roundHalfTowardsZero = ps;
exports.roundHalfUp = us;
exports.roundUp = ss;
exports.seededRandom = Lo;
exports.setUuidDefaultEncoding = Fa;
exports.setupEnv = rc;
exports.setupWebCrypto = Yu;
exports.size = Ss;
exports.sleep = Ti;
exports.sortedItems = Wn;
exports.sortedOrderby = Eo;
exports.startSortWeight = $t;
exports.stringToBoolean = ti;
exports.stringToFloat = ri;
exports.stringToInteger = ni;
exports.stringToPath = Mr;
exports.stringToUInt8Array = tt;
exports.suid = Ra;
exports.suidBytes = Vt;
exports.suidBytesDate = hr;
exports.suidDate = Ua;
exports.sum = An;
exports.throttle = wu;
exports.timeout = Li;
exports.toBase64 = it;
exports.toBase64Url = ao;
exports.toBool = ai;
exports.toCamelCase = ht;
exports.toCapitalize = kn;
exports.toCapitalizeWords = Yo;
exports.toFloat = oi;
exports.toHex = rt;
exports.toHumanReadableFilePath = pc;
exports.toHumanReadableUrl = Zn;
exports.toInt = ii;
exports.toPath = We;
exports.toString = si;
exports.toUint8Array = F;
exports.toValidFilename = kt;
exports.today = Si;
exports.tryTimeout = Et;
exports.uname = B;
exports.unescapeHTML = qi;
exports.useAsyncMutex = pa;
exports.useBase = G;
exports.useDefer = sa;
exports.useDispose = oe;
exports.useDisposer = ia;
exports.useEventListener = ca;
exports.useExitHandler = _u;
exports.useInterval = ua;
exports.useLevelFilter = z;
exports.useMessageHub = Ja;
exports.useMutex = da;
exports.useNamespaceFilter = _;
exports.usePool = pu;
exports.usePubSub = eu;
exports.useRPC = nu;
exports.useSorted = bs;
exports.useTimeout = aa;
exports.uuid = J;
exports.uuid32bit = Ma;
exports.uuidB32 = cr;
exports.uuidB62 = sr;
exports.uuidBytes = He;
exports.uuidDecode = Wt;
exports.uuidDecodeB32 = fr;
exports.uuidDecodeB62 = ur;
exports.uuidDecodeV4 = mr;
exports.uuidEncode = xr;
exports.uuidEncodeB32 = lr;
exports.uuidEncodeB62 = ar;
exports.uuidEncodeV4 = gr;
exports.uuidIsValid = ka;
exports.uuidv4 = pr;
exports.valueToBoolean = Q;
exports.valueToFloat = In;
exports.valueToInteger = Cn;
exports.valueToPath = Fr;
exports.valueToString = Fe;
exports.waitOn = Ai;
exports.writeText = hc;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map