import { J as Json, O as ObjectStorage, L as LogHandlerOptions, a as LogHandler, b as LogLevelAliasType, c as LoggerInterface } from './uuid-7fc4901a.js';
export { dQ as ArgumentsType, cD as AsyncMutex, cX as AsyncReturnType, $ as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, dq as Channel, dp as ChannelMessageEvent, dD as CryptoEncoder, az as DAY_MS, aY as Day, aB as DayInput, aX as DayInputLegacy, aA as DayValue, b2 as DecimalInput, b1 as DecimalValue, dw as DefaultListener, d4 as DefaultLogger, ct as Disposable, cs as Disposer, cr as DisposerFunction, dx as Emitter, du as EmitterAllHandler, dt as EmitterHandler, dA as Encoder, bv as FilterFunction, dC as JsonEncoder, dv as ListenerSignature, dr as LocalChannel, d5 as LogLevel, dd as LogLevelAlias, de as LogLevelAliasKey, d6 as LogLevelAll, d7 as LogLevelDebug, da as LogLevelError, db as LogLevelFatal, d8 as LogLevelInfo, dc as LogLevelOff, d9 as LogLevelWarn, df as LogMessage, di as LoggerConsoleHandler, dh as LoggerContext, dg as LoggerContextInterface, dn as LoggerMemoryHandler, bw as MapperFunction, e9 as MemStorage, e8 as MemStorageOptions, dG as Message, dE as MessageAction, dK as MessageDefinitions, dL as MessageHub, dF as MessageResult, dI as MessagesDefaultMethods, dJ as MessagesMethods, dH as MessagesOptions, cC as Mutex, ed as NestedArray, dB as NoopEncoder, cH as PoolConfig, cK as PoolTask, cL as PoolTaskEvents, cI as PoolTaskFn, cG as PoolTaskIdConflictResolution, cJ as PoolTaskState, bc as Primitive, cN as Progress, dO as PubSub, dT as RPCFn, dS as RPCOptions, dU as RPCReturn, av as RenderMessagesOptions, dR as ReturnType, bV as RoundingMode, c_ as SerialQueue, c4 as SortableItem, cZ as TaskEvents, cY as TaskFn, af as Uint8ArrayToHexDump, ae as Uint8ArrayToJson, a3 as Uint8ArrayToString, cy as UseDefer, cv as UseDispose, cq as XRX, a1 as _decodeUtf8Polyfill, a0 as _encodeUtf8Polyfill, _ as _useBase, M as arrayAvg, N as arrayBatches, y as arrayEmptyInPlace, w as arrayFilterInPlace, q as arrayFlatten, s as arrayIntersection, B as arrayIsEqual, H as arrayMax, I as arrayMin, o as arrayMinus, G as arrayRandomElement, u as arrayRemoveElement, v as arraySetElement, E as arrayShuffle, F as arrayShuffleForce, D as arrayShuffleInPlace, z as arraySorted, A as arraySortedNumbers, K as arraySum, t as arraySymmetricDifference, x as arrayToggleInPlace, p as arrayUnion, n as arrayUnique, bI as avg, bG as between, ck as cloneJsonObject, cj as cloneObject, bR as cmp, bQ as composeOrderby, P as createArray, ds as createLocalChannelPair, cO as createPromise, dM as createPromiseProxy, l as csvParse, m as csvParseToObjects, k as csvStringify, b0 as dateStringToDays, a$ as day, aE as dayDay, aU as dayDiff, aI as dayFromAny, aK as dayFromDate, aL as dayFromDateGMT, aP as dayFromParts, aQ as dayFromString, aN as dayFromTimestamp, aH as dayFromToday, aW as dayIterator, aD as dayMonth, aR as dayMonthStart, aT as dayOffset, aV as dayRange, aG as dayToDate, aJ as dayToDateGMT, aF as dayToParts, aO as dayToString, aM as dayToTimestamp, aC as dayYear, aS as dayYearStart, d0 as debounce, b3 as decimal, b6 as decimalCentsPart, b4 as decimalFromCents, b5 as decimalToCents, U as decodeBase16, S as decodeBase32, W as decodeBase58, Y as decodeBase62, j as decrypt, b7 as deepEqual, b9 as deepMerge, b8 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, e5 as detect, g as digest, ci as empty, T as encodeBase16, R as encodeBase32, V as encodeBase58, X as encodeBase62, cc as encodeQuery, i as encrypt, c6 as endSortWeight, ce as ensureKey, cf as ensureKeyAsync, ac as equalBinary, ba as escapeHTML, bU as escapeRegExp, Z as estimateSizeForBase, dY as fetchBasic, dZ as fetchJson, e1 as fetchOptionsBasicAuth, d$ as fetchOptionsFormURLEncoded, e0 as fetchOptionsJson, d_ as fetchText, ay as fixBrokenUth8String, aZ as forEachDay, cn as forTimes, aw as formatMessages, eb as formatMilliseconds, aa as fromBase64, ab as fromBase64String, aj as fromCamelCase, a7 as fromHex, e4 as getGlobal, d1 as getGlobalContext, dy as getGlobalEmitter, d3 as getGlobalLogger, dj as getNamespaceFilterString, e3 as getNavigator, bB as getSecureRandom, bC as getSecureRandomIfPossible, ea as getTimestamp, e2 as getWindow, dW as httpMethod, cQ as immediate, bf as isArray, bm as isBoolean, e6 as isBrowser, bX as isEven, bW as isHalf, bk as isInteger, d2 as isLocalHost, bq as isNotNull, bo as isNull, bn as isNullOrUndefined, bj as isNumber, bd as isObject, bK as isPrime, bJ as isPrimeRX, be as isPrimitive, cV as isPromise, bg as isRecord, bh as isRecordPlain, bl as isSafeInteger, bi as isString, cS as isTimeout, bp as isUint8Array, br as isValue, a5 as joinToUint8Array, bu as jsonStringify, bt as jsonStringifySafe, bs as jsonStringifySorted, ad as jsonToUint8Array, ch as last, dz as lazyListener, ca as linkifyPlainText, bz as listDistinctUnion, by as listGroupBy, bA as listOfKey, bx as listQuery, cl as memoize, cm as memoizeAsync, c7 as moveSortWeight, ee as noop, bO as objectIsEmpty, bM as objectMap, bN as objectMergeDisposable, dX as parseBasicAuth, ec as parseDate, dl as parseLogLevel, bP as parseOrderby, cd as parseQuery, cW as promisify, eA as qid, bD as randomBoolean, bF as randomFloat, bE as randomInt, r as randomUint8Array, cp as regExpEscape, co as regExpString, ax as renderMessages, bZ as roundDown, c0 as roundHalfAwayFromZero, c1 as roundHalfDown, c2 as roundHalfEven, b$ as roundHalfOdd, c3 as roundHalfTowardsZero, b_ as roundHalfUp, bY as roundUp, bL as seededRandom, eu as setUuidDefaultEncoding, cg as size, cP as sleep, c8 as sortedItems, bS as sortedOrderby, c5 as startSortWeight, ak as stringToBoolean, am as stringToFloat, al as stringToInteger, a2 as stringToUInt8Array, eq as suid, ep as suidBytes, es as suidBytesDate, er as suidDate, bH as sum, c$ as throttle, cR as timeout, a8 as toBase64, a9 as toBase64Url, au as toBool, ag as toCamelCase, ah as toCapitalize, ai as toCapitalizeWords, ar as toFloat, a6 as toHex, cb as toHumanReadableUrl, as as toInt, at as toString, a4 as toUint8Array, bT as toValidFilename, a_ as today, cT as tryTimeout, ez as uname, bb as unescapeHTML, cF as useAsyncMutex, Q as useBase, cx as useDefer, cu as useDispose, cw as useDisposer, cB as useEventListener, e7 as useExitHandler, cA as useInterval, dm as useLevelFilter, dN as useMessageHub, cE as useMutex, dk as useNamespaceFilter, cM as usePool, dP as usePubSub, dV as useRPC, c9 as useSorted, cz as useTimeout, ev as uuid, et as uuid32bit, ej as uuidB32, eg as uuidB62, ef as uuidBytes, ew as uuidDecode, el as uuidDecodeB32, ei as uuidDecodeB62, eo as uuidDecodeV4, ex as uuidEncode, ek as uuidEncodeB32, eh as uuidEncodeB62, en as uuidEncodeV4, ey as uuidIsValid, em as uuidv4, an as valueToBoolean, ap as valueToFloat, ao as valueToInteger, aq as valueToString, cU as waitOn } from './uuid-7fc4901a.js';

/** @deprecated */
declare function urlBase64ToUint8Array(base64String: string): Uint8Array | undefined;

declare function gravatarURLByEmail(email: string, defaultURL?: string): string;

interface LocalStorageOptions {
    name: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
}
declare class LocalStorage<T = Json> implements ObjectStorage<T> {
    private name;
    private prefix;
    private pretty;
    private objectFromString;
    private objectToString;
    constructor(opt: LocalStorageOptions);
    setItem(key: string, value: T): void;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function LoggerBrowserHandler(opt?: LogHandlerOptions): LogHandler;

declare function LoggerBrowserSetupDebugFactory(opt?: LogHandlerOptions): (name?: string, logLevel?: LogLevelAliasType) => LoggerInterface;
/** @deprecated This output is default for initial use of Logger in browser environments. */
declare function activateConsoleDebug(_opt?: LogHandlerOptions): void;

declare function supportsColors(): boolean;
declare function selectColor(namespace: string): string;

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { Json, LocalStorage, LocalStorageOptions, LogHandler, LogHandlerOptions, LogLevelAliasType, Logger, LoggerBrowserHandler, LoggerBrowserSetupDebugFactory, LoggerInterface, ObjectStorage, activateConsoleDebug, gravatarURLByEmail, selectColor, supportsColors, urlBase64ToUint8Array };
